/*
 * fancyqt4linerecord.h
 *
 *  Created on: 19.11.2011
 *      Author: wglas
 */

#ifndef FANCYQT4WIDGETS_LINERECORD_H_
#define FANCYQT4WIDGETS_LINERECORD_H_

#include <fancyqt4widgets.h>
#include <QtCore/QString>
#include <QtCore/QVector>

namespace Fancy {
namespace Qt4 {
namespace Widgets {

class FANCYQT4WIDGETS_API LineRecord {

	QString text;
	int lineNumber;
public:
	LineRecord() : lineNumber(0) {}
	LineRecord(const QString &_text, int _lineNo) : text(_text),lineNumber(_lineNo) {}
	LineRecord(const LineRecord &rec) : text(rec.text), lineNumber(rec.lineNumber) {}

	LineRecord &operator=(const LineRecord &rec);

	const QString &getText() const { return this->text; }
	void setText(const QString &_text) { this->text = _text; }

	int getLineNumber() const { return this->lineNumber; }
	void setLineNumber(int n) { this->lineNumber = n; }

	~LineRecord();
};

typedef QVector<LineRecord> LineRecordList;

} /* namespace Widgets */
} /* namespace Qt4 */
} /* namespace Fancy */
#endif /* FANCYQT4LINERECORD_H_ */
