/*
 * LogFileWatchdog.h
 *
 *  Created on: 17.11.2011
 *      Author: wglas
 */

#ifndef FANCYQT4WIDGETS_LOGFILEWATCHDOG_H_
#define FANCYQT4WIDGETS_LOGFILEWATCHDOG_H_

#include <fancyqt4linerecord.h>
#include <QtCore/QObject>

namespace Fancy {
namespace Qt4 {
namespace Widgets {
namespace impl { class LogFileWatchdogThread; }

class FANCYQT4WIDGETS_API LogFileWatchdog : public QObject {

	Q_OBJECT

	Q_PROPERTY(QString searchString READ getSearchString WRITE setSearchString)

	impl::LogFileWatchdogThread *d;

public:
    LogFileWatchdog(QObject *parent);
    virtual ~LogFileWatchdog();

    Q_SLOT void open(const QString &fn, QTextCodec *codec);

    Q_SLOT void requestLines(int firstLine, int nlines);
    Q_SLOT void requestStop();

    Q_SLOT void setSearchString(const QString &s);

    QString getSearchString() const;

    Q_SIGNAL void finished();
    Q_SIGNAL void ioError(const QString &message);
    Q_SIGNAL void linesRead(int firstLine, const Fancy::Qt4::Widgets::LineRecordList &lines);
    Q_SIGNAL void nlinesChanged(int nLines);
    Q_SIGNAL void contentChanged(int nLines, int lineHint);

    /**
     * Wait for the thread to stop after issuing @c requestStop().
     */
    void waitForStop();
};

} /* namespace Widgets */
} /* namespace Qt4 */
} /* namespace Fancy */
#endif /* FANCYQT4WIDGETS_LOGFILEWATCHDOG_H_ */
